`timescale 1ns / 1ps

module TopBCD(enable, clk, money, hundred, fivehundred, first_sum, second_sum, done);
	input enable;
	input clk;	
	input [7:0] money;
	input hundred;
	input fivehundred;
	
	output reg [3:0] first_sum;
	output reg [3:0] second_sum;
	output reg done;
	
	
	reg [3:0] sum_clk;
	reg [3:0] newmoney;
	reg [3:0] oldmoney1;
	reg [3:0] oldmoney2;
	reg select;
	reg [3:0] tmp_f_sum;
	

	wire[3:0] tmp_first_sum;
	wire[3:0] tmp_second_sum;
	wire tmp_outcarry;
	wire last_outcarry;	
	

	always @(negedge(clk))
	begin
	    
	if(hundred == 1)	
	begin
		newmoney <= 4'b0001;
		oldmoney1 <=  money[3:0];
		oldmoney2 <=  money[7:4];
	end
	
	else if(fivehundred == 1) begin
		newmoney <= 4'b0101;
		oldmoney1 <= money[3:0];
	  	oldmoney2 <= money[7:4];
	end
	
	else begin	
		newmoney <= 4'b0000;
		oldmoney1 <= money[3:0];
	  	oldmoney2 <= money[7:4];
	end
	
	end
	
	bcd_adder go1 (.rst(select), .clk(clk), .a(newmoney), .b(oldmoney1), .carry(1'b0) , .sum(tmp_first_sum), .outcarry(tmp_outcarry));
	bcd_adder go2 (.rst(~select), .clk(clk), .a(4'b0000), .b(oldmoney2), .carry(tmp_outcarry) , .sum(tmp_second_sum), .outcarry(last_outcarry));
	
	always @(posedge(clk))
	begin
	   if (enable == 1)
   		   sum_clk <= sum_clk + 3'b001;
   	   else 
   		   sum_clk <= 3'b000;		   
	end
	
	always @(sum_clk)
	begin
		if (sum_clk == 0)
 	   begin			
			select <= 1'b1;
			done<=0;
		end		
		
		else if (sum_clk == 4)
 	   begin
 	   	 tmp_f_sum <= tmp_first_sum;			
			select <= 1'b0;
			done<=0;			
		end
		else if(sum_clk==8) begin
			first_sum <= tmp_f_sum;
			second_sum <= tmp_second_sum;
			done<=0;
		end
		else if(sum_clk==9) done<=1;
		else
		begin
			first_sum<=money[3:0];
			second_sum<=money[7:4];
			done<=0;
		end
	end

	
endmodule


