`timescale 1ns / 1ps

module admin(enable_start, stop, clk, item1, item2, item3, item4, push, out_item1, out_item2, out_item3, out_item4, done);
	input enable_start;
	input stop;
	input clk;
	input [3:0]item1;
	input [3:0]item2;
	input [3:0]item3;
	input [3:0]item4; 
	input [3:0]push;
	
	output reg [3:0] out_item1;
	output reg [3:0] out_item2;
	output reg [3:0] out_item3;
	output reg [3:0] out_item4;
	output reg done;
	
	reg [3:0] save_item1;
	reg [3:0] save_item2;
	reg [3:0] save_item3;
	reg [3:0] save_item4;
	reg input_flag;

always@(posedge(clk)) begin
	if (enable_start==0) begin
		 save_item1 <= 4'b0000;
		 save_item2 <= 4'b0000;
		 save_item3 <= 4'b0000;
		 save_item4 <= 4'b0000;

		out_item1 <= 4'b0000;
		out_item2 <= 4'b0000;
		out_item3 <= 4'b0000;
		out_item4 <= 4'b0000;
		
		input_flag <= 1'b0;
		done <= 1'b0;
	end 
	else begin
	   if (input_flag==0 ) begin
			save_item1 <= item1;
			save_item2 <= item2;
			save_item3 <= item3;
			save_item4 <= item4;
			
			input_flag<=1'b1;
  	    end 		
   	   else if (stop ==1) begin
			out_item1 <= save_item1;
			out_item2 <= save_item2;
			out_item3 <= save_item3;
			out_item4 <= save_item4;
			
			done <=1'b1;
   	   end	
   	   else begin
         case (push) 
			5'b00001 :  save_item1 <= save_item1 + 1'b1;
			5'b00010 :  save_item2 <= save_item2 + 1'b1;
			5'b00100 :  save_item3 <= save_item3 + 1'b1;
			5'b01000 :  save_item4 <= save_item4 + 1'b1;
			default: begin	
					   save_item1 <= save_item1;
					   save_item2 <= save_item2;
					   save_item3 <= save_item3;				
					   save_item4 <= save_item4;
			         end
		   endcase
       end
	 end
	 
   end	

endmodule
