`timescale 1ns / 1ps

module bcd_adder(rst, clk, a, b, carry ,sum,outcarry);

	input rst;
	input clk;	
	input [3:0]a;
	input [3:0]b;
	input carry;
	output reg [3:0] sum;
	output reg outcarry;

	wire first_out_carry;
	wire [3:0] first_out_sum;
	wire last_out_carry;
	wire [3:0] last_out_sum;
	wire [3:0] six;
	

	reg [1:0] total_clk;

	fourbit_adder u1(.clk(clk), .in_x(a), .in_y(b), .in_carry(carry), .out_carry(first_out_carry), .out_sum(first_out_sum));
	fourbit_adder u2(.clk(clk), .in_x(six), .in_y(first_out_sum), .in_carry(1'b0), .out_carry(last_out_carry), .out_sum(last_out_sum));

	assign six[0] = 1'b0;
	assign six[1] = ((first_out_sum[3] & first_out_sum[2]) | (first_out_sum[3] & first_out_sum[1]) | first_out_carry);
	assign six[2] = ((first_out_sum[3] & first_out_sum[2]) | (first_out_sum[3] & first_out_sum[1]) | first_out_carry);
	assign six[3] = 1'b0;

	always@(posedge(clk))
	begin
	   if (rst == 1'b1)
   		   total_clk <= total_clk + 2'b01;
   		else 
   		   total_clk <= 2'b00;
	end
	
	always@(total_clk)
	begin
		if (total_clk == 2'b11)
 	   	begin
			outcarry <= ((first_out_sum[3] & first_out_sum[2]) | (first_out_sum[3] & first_out_sum[1]) | first_out_carry);
			sum <= last_out_sum;
		end
		else begin
			outcarry<=1'bz;
			sum <= last_out_sum;
		end
	end

endmodule
