`timescale 1ns / 1ps

module complements (clk, in_x, out_y);
	input clk;
	input [7:0] in_x;
	output reg [7:0] out_y;

	wire [7:0] complement_1;
	   
	wire tmp_sum_1;
	wire tmp_sum_2;
	wire tmp_sum_3;
	wire tmp_sum_4;
	wire tmp_sum_5;
	wire tmp_sum_6;
	wire tmp_sum_7;
	wire tmp_sum_8;
	
	wire tmp_carryout_1;
	wire tmp_carryout_2;
	wire tmp_carryout_3;
	wire tmp_carryout_4;
	wire tmp_carryout_5;
	wire tmp_carryout_6;
	wire tmp_carryout_7;
	wire tmp_carryout_8;

	eight_xor change(.a(in_x), .b(complement_1));
	onebit_adder u1(.x(complement_1[0]), .y(1'b0), .c_in(1'b1), .sum_out(tmp_sum_1), .c_out(tmp_carryout_1));
	onebit_adder u2(.x(complement_1[1]), .y(1'b0), .c_in(tmp_carryout_1), .sum_out(tmp_sum_2), .c_out(tmp_carryout_2));
	onebit_adder u3(.x(complement_1[2]), .y(1'b0), .c_in(tmp_carryout_2), .sum_out(tmp_sum_3), .c_out(tmp_carryout_3));
	onebit_adder u4(.x(complement_1[3]), .y(1'b0), .c_in(tmp_carryout_3), .sum_out(tmp_sum_4), .c_out(tmp_carryout_4));
	onebit_adder u5(.x(complement_1[4]), .y(1'b0), .c_in(tmp_carryout_4), .sum_out(tmp_sum_5), .c_out(tmp_carryout_5));
	onebit_adder u6(.x(complement_1[5]), .y(1'b0), .c_in(tmp_carryout_5), .sum_out(tmp_sum_6), .c_out(tmp_carryout_6));
	onebit_adder u7(.x(complement_1[6]), .y(1'b0), .c_in(tmp_carryout_6), .sum_out(tmp_sum_7), .c_out(tmp_carryout_7));
	onebit_adder u8(.x(complement_1[7]), .y(1'b0), .c_in(tmp_carryout_7), .sum_out(tmp_sum_8), .c_out(tmp_carryout_8));

	always@(posedge(clk))
	begin
		out_y<=8'bz;
	end
	
	always@(negedge(clk))
	begin
		out_y<={tmp_sum_8, tmp_sum_7, tmp_sum_6, tmp_sum_5, tmp_sum_4, tmp_sum_3, tmp_sum_2, tmp_sum_1};
	end

endmodule
