`timescale 1ns / 1ps

module controller(rst, clk, enable, work, seg_com, seg_data, five, one, sold_out1, sold_out2, sold_out3, sold_out4, goods_out, selling);
	input rst;
	input clk;
	input [12:0] enable;

	output reg work;
	output reg [7:0] seg_com;
	output reg [6:0] seg_data;
	output reg five;
	output reg one;
	output reg sold_out1;
	output reg sold_out2;
	output reg sold_out3;
	output reg sold_out4;
	output reg goods_out;
	output reg selling;
	
	reg [7:0] money;	//
	reg [12:0] ex_enable;	//Ȯ enable;

	reg [3:0] quan1;	//1 
	reg [3:0] quan2;	//ǰ2 
	reg [3:0] quan3;	//ǰ3 
	reg [3:0] quan4;	//ǰ4 

	wire M_goods_1;	//ǰ Ϸ
	wire M_goods_2;	//ǰ Ϸ
	wire M_goods_3;	//ǰ Ϸ
	wire M_goods_4;	//ǰ Ϸ
	wire M_bcdadder;	// Ϸx_enable[5]), .fivehundred(ex_enable[6]), .first_sum(first_sum), .second_sum(second_sum), .done(M_bcdadder));


	wire M_refund;	//ȯ Ϸ
	wire M_admin; //  Ϸ
	wire [7:0] M_money_1;
	wire [7:0] M_money_2;
	wire [7:0] M_money_3;
	wire [7:0] M_money_4;
	wire [3:0] M_quan_1;
	wire [3:0] M_quan_2;
	wire [3:0] M_quan_3;
	wire [3:0] M_quan_4;
	wire [3:0] out_item_1;
	wire [3:0] out_item_2;
	wire [3:0] out_item_3;
	wire [3:0] out_item_4;
	wire [7:0] refund_money;
	wire finish_signal;	//Ϸȣ Ѱ
	wire push_adder;	// enable
	wire [3:0] first_sum;
	wire [3:0] second_sum;
	wire [7:0] temp_sum;	//  
	wire [3:0] push;
	wire clk2;
	wire temp_goods_out;      // modified_by_smkcow
	wire [7:0] temp_seg_com;  // modified_by_smkcow
	wire [6:0] temp_seg_data; // modified_by_smkcow
	wire temp_five;           // modified_by_smkcow
	wire temp_one;            // modified_by_smkcow
	wire sub_done;	// modified_by_smkcow


	assign temp_goods_out=M_goods_1 | M_goods_2 | M_goods_3 | M_goods_4;
	assign push={enable[11], enable[10], enable[9], enable[8]};
	assign push_adder=ex_enable[5] | ex_enable[6];
	assign finish_signal=M_goods_1 | M_goods_2 | M_goods_3 | M_goods_4 | M_bcdadder | M_refund | M_admin;
	assign temp_sum[0]=first_sum[0];
	assign temp_sum[1]=first_sum[1];
	assign temp_sum[2]=first_sum[2];
	assign temp_sum[3]=first_sum[3];
	assign temp_sum[4]=second_sum[0];
	assign temp_sum[5]=second_sum[1];
	assign temp_sum[6]=second_sum[2];
	assign temp_sum[7]=second_sum[3];
	
	//ǰ clk-4  
	goods1 g_one(.enable(ex_enable[0]), .clk(clk2), .in_quan(quan1), .in_money(money), .out_quan(M_quan_1), .out_money(M_money_1), .done(M_goods_1));
	goods2 g_two(.enable(ex_enable[1]), .clk(clk2), .in_quan(quan2), .in_money(money), .out_quan(M_quan_2), .out_money(M_money_2), .done(M_goods_2));
	goods3 g_three(.enable(ex_enable[2]), .clk(clk2), .in_quan(quan3), .in_money(money), .out_quan(M_quan_3), .out_money(M_money_3), .done(M_goods_3));
	goods4 g_four(.enable(ex_enable[3]), .clk(clk2), .in_quan(quan4), .in_money(money), .out_quan(M_quan_4), .out_money(M_money_4), .done(M_goods_4));

	//7seg posedge(clk) 
	segment sg(.clk(clk), .rst(rst), .money(money), .seg_com(temp_seg_com), .seg_data(temp_seg_data));

	//   clk-11  
	TopBCD bcd(.enable(push_adder), .clk(clk), .money(money), .hundred(ex_enable[5]), .fivehundred(ex_enable[6]), .first_sum(first_sum), .second_sum(second_sum), .done(M_bcdadder));

	//ȯ
	refund rf(.clk(clk2), .enable(ex_enable[4]), .in_money(money), .out_money(refund_money), .five(temp_five), .one(temp_one), .done(M_refund), .sub_done(sub_done));

	// 
	admin ad(.enable_start(ex_enable[7]), .stop(enable[12]), .clk(clk), .item1(quan1), .item2(quan2), .item3(quan3), .item4(quan4), .push(push), .out_item1(out_item_1), .out_item2(out_item_2), .out_item3(out_item_3), .out_item4(out_item_4), .done(M_admin));
	
	//delay_clk
	delay_clk cl2(.rst(rst), .clk(clk), .d_clk(clk2));


  	always@(clk) begin
    	   goods_out<=temp_goods_out;
    	   seg_com<=temp_seg_com;
    	   seg_data<=temp_seg_data;
    	   five<=temp_five;
    	   one<=temp_one;
	end
	
	always@(clk) begin
		if(quan1==0) sold_out1<=1;
		else sold_out1<=0;
	end
	
	always@(clk) begin
		if(quan2==0) sold_out2<=1;
		else sold_out2<=0;
	end
	
	always@(clk) begin
		if(quan3==0) sold_out3<=1;
		else sold_out3<=0;
	end
	
	always@(clk) begin
		if(quan4==0) sold_out4<=1;
		else sold_out4<=0;
	end
		
//	always@(clk) begin
  	always@(posedge(clk)) begin
		if(rst==1) begin
			ex_enable<=0;
			money<=8'b0000_0000;
			quan1<=0;
			quan2<=0;
			quan3<=0;
			quan4<=0;
			work<=0;
			selling<=1;
		end
		else begin
		if(finish_signal==1) begin
			work<=0;
			case(ex_enable)
				1 : begin
					money<=M_money_1;
					quan1<=M_quan_1;
					ex_enable<=0;
				end
				2 : begin
					money<=M_money_2;
					quan2<=M_quan_2;
					ex_enable<=0;
				end
				4 : begin
					money<=M_money_3;
					quan3<=M_quan_3;
					ex_enable<=0;
				end
				8 : begin
					money<=M_money_4;
					quan4<=M_quan_4;
					ex_enable<=0;
				end
				16 : begin
					ex_enable<=0;
				end
				32 : begin
					money<=temp_sum;
					ex_enable<=0;
				end
				64 : begin
					money<=temp_sum;
					ex_enable<=0;
				end
				4096 : begin
					ex_enable<=0;
					quan1<=out_item_1;
					quan2<=out_item_2;
					quan3<=out_item_3;
					quan4<=out_item_4;
				end
			endcase
		end
		else begin
			if(ex_enable==16 & sub_done==1) money<=refund_money;
			else begin
				case(enable)
					1 : begin
						ex_enable<=1;
						work<=1;
					end
					2 : begin
						ex_enable<=2;
						work<=1;
					end
					4 : begin
						ex_enable<=4;
						work<=1;
					end
					8 : begin
						ex_enable<=8;
						work<=1;
					end
					16 : begin
						ex_enable<=16;
						work<=1;
					end
					32 : begin
						ex_enable<=32;
						work<=1;
					end
					64 : begin
						ex_enable<=64;
						work<=1;
					end
					128 : begin
						ex_enable<=128;
						selling<=0;
						work<=0;
					end
					4096 : begin
						ex_enable<=4096;
						selling<=1;
						work<=1;
					end
				endcase
			end
		end
		end
	end

endmodule
