`timescale 1ns / 1ps

module fourbit_adder(clk, in_x, in_y, in_carry, out_carry, out_sum);
	input clk;
	input [3:0]in_x;
	input [3:0]in_y;
	input in_carry;
	output reg out_carry;
	output reg [3:0] out_sum;

  	reg [3:0] cal_x;
  	reg [3:0] cal_y;
   
	wire tmp_sum_1;
	wire tmp_sum_2;
	wire tmp_sum_3;
	wire tmp_sum_4;

	
	wire tmp_carryout_1;
	wire tmp_carryout_2;
	wire tmp_carryout_3;
	wire tmp_carryout_4;
	

	onebit_adder u1(.x(cal_x[0]), .y(cal_y[0]), .c_in(in_carry), .sum_out(tmp_sum_1), .c_out(tmp_carryout_1));
	onebit_adder u2(.x(cal_x[1]), .y(cal_y[1]), .c_in(tmp_carryout_1), .sum_out(tmp_sum_2), .c_out(tmp_carryout_2));
	onebit_adder u3(.x(cal_x[2]), .y(cal_y[2]), .c_in(tmp_carryout_2), .sum_out(tmp_sum_3), .c_out(tmp_carryout_3));
	onebit_adder u4(.x(cal_x[3]), .y(cal_y[3]), .c_in(tmp_carryout_3), .sum_out(tmp_sum_4), .c_out(tmp_carryout_4));

	always@(posedge(clk))
	begin
		cal_x <=in_x;
		cal_y <=in_y;
					
	end

	always@(negedge(clk))
	begin
		out_carry <= tmp_carryout_4 ;
		out_sum <={tmp_sum_4, tmp_sum_3, tmp_sum_2, tmp_sum_1} ;
		
	end
	

endmodule
