`timescale 1ns / 1ps

module goods1(enable, clk, in_quan, in_money, out_quan, out_money, done);
	input enable;
	input clk;
	input [3:0] in_quan;
	input [7:0] in_money;
	output reg [3:0] out_quan;
	output reg [7:0] out_money;
	output reg done;
	
	wire [7:0] goods_money;
	reg [1:0] count;
	wire [7:0] temp_money;
	wire [3:0] temp_quan;

	assign goods_money=8'b00000111;

	// (3 clk)
	bcd_subtractor one(.enable(enable), .clk(clk), .in_quan(in_quan), .in_money(in_money), .goods_money(goods_money), .out_money(temp_money), .out_quan(temp_quan));

	always@(posedge(clk)) begin
		if(enable==1'b1)
			count<=count+1;
		else
			count<=0;
	end

	always@(count) begin
		if(count==3) begin
			out_quan<=temp_quan;
			out_money<=temp_money;
			done<=1;
		end
		else begin
			out_quan<=in_quan;
			out_money<=in_money;
			done<=0;
		end
	end

endmodule
