`timescale 1ns / 1ps

module onebit_adder(x, y, c_in, sum_out, c_out);
	input x, y, c_in;
	output sum_out, c_out;
	
	wire [2:0] d_in;
	reg [1:0] d_out;
	
	assign d_in = {x, y, c_in};
	assign c_out = d_out[1];
	assign sum_out = d_out[0];
	
	always @(d_in)
	begin
		case (d_in)
			0 : d_out = 2'b00;
			1 : d_out = 2'b01;
			2 : d_out = 2'b01;
			3 : d_out = 2'b10;
			4 : d_out = 2'b01;
			5 : d_out = 2'b10;
			6 : d_out = 2'b10;
			7 : d_out = 2'b11;
		endcase
	end
		
endmodule
