`timescale 1ns / 1ps

module segment(clk, rst, money, seg_com, seg_data);
	input clk;
	input rst;
	input [7:0] money;
	
	output reg [7:0] seg_com;
	output reg [6:0] seg_data;
	
	reg [1:0] total_clk;
	wire [3:0] money1;
	wire [3:0] money2;
	
	assign money1=money[3:0];
	assign money2=money[7:4];
	
	always@(posedge(clk)) begin
		if(rst==1) total_clk<=0;
		else total_clk<=total_clk+1;
	end
	
	always @(total_clk) begin
		if(total_clk == 1) begin
			seg_com <= 8'b10111111;
			seg_data <= 7'b0111111;
		end
		else if(total_clk == 2) begin			
			seg_com <= 8'b11011111;
			case(money1)
				0 : seg_data <= 7'b0111111;
				1 : seg_data <= 7'b0000110;
				2 : seg_data <= 7'b1011011;
				3 : seg_data <= 7'b1001111;
				4 : seg_data <= 7'b1100110;
				5 : seg_data <= 7'b1101101;
				6 : seg_data <= 7'b1111101;
				7 : seg_data <= 7'b0000111;
				8 : seg_data <= 7'b1111111;
				9 : seg_data <= 7'b1100111;
			endcase
		end
		else if(total_clk == 3) begin
			seg_com <= 8'b11101111;
			case(money2)
				0 : seg_data <= 7'b0111111;
				1 : seg_data <= 7'b0000110;
				2 : seg_data <= 7'b1011011;
				3 : seg_data <= 7'b1001111;
				4 : seg_data <= 7'b1100110;
				5 : seg_data <= 7'b1101101;
				6 : seg_data <= 7'b1111101;
				7 : seg_data <= 7'b0000111;
				8 : seg_data <= 7'b1111111;
				9 : seg_data <= 7'b1100111;
			endcase		
		end
		else begin			
			seg_com <= 8'b01111111;
			seg_data <= 7'b0111111;
		end	
	end
endmodule
