`timescale 1ns/1ps

module tb_admin;

	reg [1:0]key;	
	reg [4:0]item1;
	reg [4:0]item2;
	reg [4:0]item3;
	reg [4:0]item4;
	reg [4:0]item5;	
	reg [4:0]push;	
	
	wire [4:0] out_item1;
	wire [4:0] out_item2;
	wire [4:0] out_item3;
	wire [4:0] out_item4;
	wire [4:0] out_item5;
	
	admin uut(
		.key(key),
		.item1(item1),	
		.item2(item2),
		.item3(item3),
		.item4(item4),
		.item5(item5),
		.push(push),
		.out_item1(out_item1),
		.out_item2(out_item2),
		.out_item3(out_item3),
		.out_item4(out_item4),
		.out_item5(out_item5)
	);
	
	initial begin
		key = 2'b00;		
		item1 = 5'b00001;
		item2 = 5'b00001;
		item3 = 5'b00001;
		item4 = 5'b00001;
		item5 = 5'b00001;
		push = 5'b00000;
	end
	
	always begin
		key = 2'b01; #50;
		key = 2'b00; #10;
		
		push = 5'b00001; #20;
		push = 5'b00010; #20;
		push = 5'b00100; #20;
		push = 5'b01000; #20;
		push = 5'b10000; #20;
		
		key = 2'b10; #20;
		key = 2'b00; #20;
		
	end	
	
endmodule
