`timescale 1ns / 1ps

module top_vending(clk, button_switch, keypad_data_i, seg_com, seg_data, five, one, sold_out1, sold_out2, sold_out3, sold_out4, goods_out, selling, keypad_scan_o);
	input clk;
	input [5:0] button_switch;
	input [3:0] keypad_data_i;

	output [7:0] seg_com;
	output [6:0] seg_data;
	output five;
	output one;
	output sold_out1;
	output sold_out2;
	output sold_out3;
	output sold_out4;
	output goods_out;
	output selling;

	output [2:0] keypad_scan_o;


	wire [12:0] enable_from_db_to_ec;
	wire [3:0] enable_from_ec_to_dc;
	wire [12:0] enable_from_dc_to_ct;
	wire controller_work;
	wire [12:0] enable;

	wire [7:0] real_key_data;

	assign enable<= {button_switch[4:0], real_key_data};
	
	keypad(.rst(button_switch[5]), .clk(clk), .keypad_data(keypad_data_i), .keypad_scan(keypad_scan_o), .real_key_data(real_key_data));
	debounce db(.clk(clk), .in(enable), .out(enable_from_db_to_ec));
	encoder ec(.in(enable_from_db_to_ec), .out(enable_from_ec_to_dc));
	decoder dc(.in(enable_from_ec_to_dc), .enable(~controller_work), .out(enable_from_dc_to_ct));
	controller ct(.rst(button_switch[5]), .clk(clk), .enable(enable_from_dc_to_ct), .work(controller_work), .seg_com(seg_com), .seg_data(seg_data), .five(five), .one(one), .sold_out1(sold_out1), .sold_out2(sold_out2), .sold_out3(sold_out3), .sold_out4(sold_out4), .goods_out(goods_out), .selling(selling));
	
endmodule
